% The following code calls Louvain clustering algorithm after "giving"
% edge-awareness to the structure A. 
%
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function COM=CSFB_cluster_f_infomap(A,f)

N=length(A);
if N==1
    COM=0;return
end

%% edge-aware structure Af, according to signal f:
[I,J]=find(triu(A,0));
aux=exp(-((f(I)-f(J)).^2)./(2*std(abs(f(I)-f(J)))^2));
Af=sparse(I,J,aux,size(A,1),size(A,2));
Af=Af+Af';
Af=Af-diag(diag(Af));

%% find the partition in subgraphs:
COM=uint32(CSFB_cluster_infomap(Af));