% The following code calls the Infomap clustering algorithm.
% 
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function COM=CSFB_cluster_infomap(A)

N=length(A);

if N<10
    COM=ones(N,1);return
end

%% get partition
self=0; % no self-loop
MS_flag=2;
COM = uint32(CSFB_infomap(A,self,MS_flag));

%% connectedness verification (for some reason, Infomap may sometimes 
%% output unconnected subgraphs in its partition)
for i=1:max(COM)
    com_mem=find(COM==i);
    is_con(i)=is_connected(A(com_mem,com_mem));
end

not_connected=find(is_con==0);
K=max(COM);
for i=1:length(not_connected)
    mems=find(COM==not_connected(i));
    [~,COM2]=CSFB_conncomp(A(mems,mems));
    for j=2:max(COM2)
        COM(mems(COM2==j))=K+1;
        K=K+1;
    end
end