% The following code computes the partition of a 2D grid in blocks of
% adjacent pixels forming squares.
% 
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function COM=CSFB_cluster_regular_2d_grid(A)

N=length(A);

aux=reshape([1:2:N]',sqrt(N)/2,sqrt(N));
aux=reshape(aux(:,[1:2:sqrt(N)]),1,N/4);
aux=[aux;aux+1;aux+sqrt(N);aux+sqrt(N)+1];

for i=1:size(aux,2)
    COM(aux(:,i))=i;
end

COM=COM';