% The following code is the synthesis cascade of a signal decomposition f0
% and an associated structure decomposition Ai.
% 
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function frec=CSFB_compute_all_levels_backwards(f0,Ai)

% number of levels of the analysis cascade
lmax=numel(Ai)+1;

frec=f0;
for l=lmax:-1:2
    % synthesis of previous level:
    frec=CSFB_compute_previous_level(frec,Ai{l-1});
end
