%Program for Image / Picture Quality Measures Calculation

%Author : Athi Narayanan S
%M.E, Embedded Systems,
%K.S.R College of Engineering
%Erode, Tamil Nadu, India.
%http://sites.google.com/site/athisnarayanan/
%s_athi1983@yahoo.co.in

%Program Description
%This program is the main entry of the application.
%This program calculates the difference Image/Picture Quality Measures

%Clear Memory & Command Window
function rec_q=CSFB_compute_image_quality(origImg,distImg)

%Size Validation
origSiz = size(origImg);
distSiz = size(distImg);
sizErr = isequal(origSiz, distSiz);
if(sizErr == 0)
    disp('Error: Original Image & Distorted Image should be of same dimensions');
    return;
end

%Mean Square Error 
rec_q.MSE = MeanSquareError(origImg, distImg);

%Peak Signal to Noise Ratio 
rec_q.PSNR = PeakSignaltoNoiseRatio(origImg, distImg);

%Normalized Cross-Correlation 
rec_q.NK = NormalizedCrossCorrelation(origImg, distImg);

%Average Difference 
rec_q.AD = AverageDifference(origImg, distImg);

%Structural Content 
rec_q.SC = StructuralContent(origImg, distImg);

%Maximum Difference 
rec_q.MD = MaximumDifference(origImg, distImg);

%Normalized Absolute Error
rec_q.NAE = NormalizedAbsoluteError(origImg, distImg);

rec_q.SSIM = ssim(origImg, distImg);

