% The following code is a synthesis block of a level of the synthesis
% cascade
% 
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function frec=CSFB_compute_previous_level(frec,Aiprev)

%% get the subgraph partition:
[TF,~] = license('checkout', 'Bioinformatics_Toolbox');
if TF==1
    [~,COM]=graphconncomp(Aiprev);
else
    [~,COM]=CSFB_conncomp(Aiprev);
end

%% size of each subgraph
[Nk,~] = histc(COM,unique(COM));

%% number of channels:
Ntilde=max(Nk);

%% get local Fourier operators:
[~,Q]=CSFB_get_Q_ordered(Aiprev,COM',Nk,Ntilde,'prev');

%% synthesize:
frec(1:size(Q{1},1))=cell2mat(Q)*frec(1:size(Q{1},1));