% The following code creates the symmetrical normalized laplacian 
%
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function Ln=CSFB_create_normlaplaciangraph(A)

if istriu(A)%istrisup(A)
    A=A+A';
elseif ~issymmetric(A)
    error('create_normlaplaciangraph: A should be tri sup or sym');
end

DEG_dem=spdiags(1./sqrt(sum(A))',0,size(A,1),size(A,2));
%DEG_dem=sparse(size(A,1),size(A,2));
%diag(DEG_dem)=1./sqrt(sum(A));

Q=speye(length(A))-DEG_dem*A*DEG_dem;

% make sure the Laplacian is exactly symmetrical:
Qbis=triu(Q,1);
Qbis=Qbis+Qbis';
Ln=Qbis+spdiags(diag(Q),0,size(A,1),size(A,2));
Ln(isnan(Ln)) = 0 ;