% The following code creates the random walk Laplacian
%
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function Lrw=CSFB_create_rwlaplaciangraph(A)

if istriu(A)
    A=A+A';
elseif ~issymmetric(A)
    error('MSCD_create_rwlaplaciangraph: A should be tri sup or sym');
end

%Lrw=eye(length(A))-diag(1./sum(A))*A;

DI = 1./sum(A);
Lrw=speye(length(A))-sparse(diag(DI))*A;
Lrw(isnan(Lrw)) = 0 ;
