% The following code creates the adjacency matrix of a grid graph.
%
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function adj=CSFB_grid_graph2d(r,c)

% adj=grid_graph2d(r,c) gives adj matrix of grid of size r rows and c
% columns

diagVec1 = repmat([ones(r-1,1); 0],c,1);  %# Make the first diagonal vector
                                          %#   (for horizontal connections)
diagVec1 = diagVec1(1:end-1);             %# Remove the last value
diagVec1=[0;diagVec1];
diagVec2 = ones(r*c,1);
adj = spdiags([diagVec1 diagVec2], [1,r], c*r, c*r);
adj = adj+adj';


% %% plot 
% 
% locationsA=zeros(r*c,2);
% locationsA(:,1)=repmat([1:r]',c,1);
% aux=repmat([1:c],r,1);
% locationsA(:,2)=aux(:);
% figure; CSFB_ggplot(adj,locationsA,20,1,1);box off; axis off;