% The following code performs the synthesis of a signal decomposition 
% f0 and an associated structure decomposition Ai. Use with perc_HF=1 if 
% you want perfect reconstruction. Play with perc_HF for non-linear 
% approximation (NLA).
%
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function [frec]=CSFB_reconstruct(f0,Ai,perc_HF,N_LP)

% get details:
detail=f0(N_LP+1:end);

% keep only perc_HF of the highest (in absolute value) high pass
% coefficients:
detail(abs(detail)<=quantile(abs(detail),1-perc_HF))=0;

% this the actual signal decomposition we reconstruct:
f0=[f0(1:N_LP);detail];

% synthesis:
frec=CSFB_compute_all_levels_backwards(f0,Ai);
