function COM=CSFB_run_Louvain(A)

global GLOBAL_CSFB; global strategy_CSFB;
global MAX_COM_CSFB;

N=length(A);

if N<10
    COM=ones(N,1);return
end

%% launch the Louvain algorithm on this graph:
dir_path =[GLOBAL_CSFB,filesep,'3rd_party',filesep,'Louvain_algorithm',filesep];
command= 'community temp/graph.bin -l -1 -w temp/graph.weights > temp/graph.tree';
%command= 'community graph.bin -l -1 -w graph.weights > graph.tree';
command = [dir_path,command];
[status,result] = system(command);

command= 'hierarchy temp/graph.tree';
%command= 'hierarchy graph.tree';
command = [dir_path,command];
result='';
% the reason why I need to do the following loop to ensure that result 
% is different than '' is obscure to me... Sometimes, at least on some 
% computers, result ends up equal to '' for no apparent reason...
while strcmp(result,'') 
    [status,result] = system(command);
end

%% analyze results of algorithm:
% get the number of levels of decomposition:
expr='\d+\n'; deb=regexp(result,expr);
expr='\n'; fin=regexp(result,expr); fin=fin(1);
N_levels=str2num(result(deb:fin-1))-1; % that's the number of levels in the community detection

if N_levels==1
    COM=ones(N,1);
    return
end

% for all levels, look at the size of all communities:
COM=zeros(N,N_levels);
sizeCOM=cell(1,N_levels);
for i=1:N_levels
    command= ['hierarchy temp/graph.tree -l ' num2str(i) ' > temp/com_level' num2str(i)];
    %command= ['hierarchy graph.tree -l ' num2str(i) ' > com_level' num2str(i)];
    command = [dir_path,command];
    [status,result] = system(command);
    comi=load(['temp/com_level' num2str(i)]);
    %comi=load(['com_level' num2str(i)]);
    COM(:,i)=comi(:,2)+1;
    [sizeCOM{i},~] = histc(COM(:,i),unique(COM(:,i)));
%     sizeCOM{i}=hist(COM(:,i),max(COM(:,i)))';
end

%% output the partition according to the value of strategy_CSFB
if N_levels>0
    if strcmp(strategy_CSFB,'largest')
        f=find(cellfun(@max,sizeCOM)<MAX_COM_CSFB,1,'last');
    elseif strcmp(strategy_CSFB,'smallest')
        f=1;
        %f=find(cellfun(@min,sizeCOM)~=1,1,'first');
    else error('CSFB_cluster_Louvain: strategy_CSFB should be either ''largest'' or ''smallest''');
    end
    COM=COM(:,f);
else
    COM=ones(N,1);
end
