% The following code separates the interior adjacency matrix from the exterior 
% adjacency matrix given a subgraph decomposition COM
%
% This file is part of the CoSub toolbox (Connected Subgraph Filterbanks 
% For Graph Signals Toolbox)
% Copyright (C) 2015, Nicolas Tremblay. 
%
% The CoSub toolbox is free software: you can redistribute 
% it and/or modify it under the terms of the GNU General 
% Public License as published by the Free Software 
% Foundation, either version 3 of the License, or (at your 
% option) any later version.
%
% The CoSub toolbox is distributed in the hope 
% that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY 
% or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
% Public License for more details.
%
% You should have received a copy of the GNU General Public 
% License along with the MSCD_Wav toolbox. 
% If not, see <http://www.gnu.org/licenses/>.

function [Ai,Ae]=CSFB_separate_Adjacency(A,COM)

COM=double(COM);
N=length(COM);
K=max(COM);

S=sparse([1:N],COM,ones(N,1),N,K);

Ai=(S*S').*A;
Ae=A-Ai;



