#include "mex.h"
#include "graph.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	/* nombre de vecteurs en entree */
	const int NB_VEC = 3;

	/* variable utilisee pour afficher un message d'erreur dans matlab s'il y a un probleme lors de l'appel de la mex-fonction */
	char msg[100];

	/* variables utilisee pour verifier que les entrees de la mex-fonction sont bien des vecteurs de meme taille */
	int nbRow[NB_VEC];
	int nbCol[NB_VEC];

	/* compteur */
	unsigned int i;
	unsigned int j;

	/* taille des NB_VEC vecteurs */
	int vec_size;

	/* pointeur vers les pointeurs des NB_VEC vecteurs */
	double** vec;
	int* src_vec, *dest_vec;
	
	const char *outfile  = "graph.bin";
	const char *outfile_w  = "graph.weights";

	
	
	if(nrhs != NB_VEC)
	{
		sprintf(msg, "La fonction mex_traitement doit avoir %d entrees",NB_VEC);
		mexErrMsgTxt(msg);
	}

	for (i=0 ; i <NB_VEC ; i++)
	{
		nbRow[i] =  mxGetM(prhs[i]);
		nbCol[i] =  mxGetN(prhs[i]);
		if(nbRow[i] != 1 && nbCol[i] != 1)
		{
			sprintf(msg, "Le parametre n°%d doit etre un vecteur",i+1);
			mexErrMsgTxt(msg);
		}
	}
	
	vec_size = nbRow[0]*nbCol[0];
	for (i=1 ; i<NB_VEC ; i++)
		if(vec_size != nbRow[i]*nbCol[i])
			mexErrMsgTxt("Tous les vecteurs n'ont pas la meme taille");

	
	vec = (double**) malloc(NB_VEC*sizeof(double*));
	for(i=0 ; i<NB_VEC ; i++)
		vec[i] = mxGetPr(prhs[i]);

	src_vec = (int*) malloc(vec_size*sizeof(int));
	dest_vec = (int*) malloc(vec_size*sizeof(int));

	for(i=0 ; i<vec_size ; i++)
		src_vec[i] = (int) vec[0][i];
	for(i=0 ; i<vec_size ; i++)
		dest_vec[i] = (int) vec[1][i];


	/*traitement(vec[0], vec[1], vec[2], vec_size);
  g=Graph(vec[0], vec[1], vec[2], vec_size, weighted_type);
  g.clean(weighted_type);
  if (do_renumber)
     g.renumber(type);
  g.display_binary(outfile, outfile_w, weighted_type);*/


Graph g(src_vec, dest_vec, vec[2], vec_size);

g.clean(WEIGHTED);
g.display_binary(outfile, outfile_w, WEIGHTED);

free(vec);
free(src_vec);
free(dest_vec);
}
