%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Code for Figure 4: multiresolution of a sensor network using the largest
% eigenvector downsampling method, Kron reduction, and graph sparsification

close all;
clear all; 
set(0,'DefaultFigureWindowStyle','docked');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set up the graph 
param.N=500;
G=gsp_create_graph('sensor',param);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generate a multiresolution of graphs
num_levels=2;
multiresolution_param.compute_full_eigen=1;
multiresolution_param.sparsify=1;
multiresolution_param.sparsify_epsilon=.5;
[Gs,subsampled_vertex_indices]=gsp_graph_multiresolution(G,num_levels,multiresolution_param);
gsp_plot_graph(Gs);