function [G]=gsp_create_bunny(small)
%GSP_CREATE_BUNNY  Initialize the bunny graph
%   Usage:  G=gsp_create_bunny();
%
%   Input parameters:
%         small : 1 for the bunny with 2503 vertices and 0 for the bunny
%                 with 8171 vertices
%   Output parameters:
%         G     : Graph structure.
%
%   'gsp_create_bunny()' initializes a graph structure containing
%   the weighted adjacency matrix (G.W), the number of vertices (G.N), the 
%   plotting coordinates (G.coords), and the plotting coordinate limits 
%   (G.coord_limits) of the bunny graph.
%
%   References: 

%   AUTHOR : David I Shuman.
%   TESTING: 
%   REFERENCE: Stanford University Computer Graphics Laboratory, "The Stanford 3D Scanning Repository," http://graphics.stanford.edu/data/3Dscanrep/ 

if small
    Q=load('bunny2k.mat');
else
    Q=load('bunny8k.mat');
    Q.L(2111,:)=[];
    Q.L(:,2111)=[];
    Q.X(:,2111)=[];
end
G.coords=Q.X';
G.N=size(Q.L,1);
G.coord_limits=[min(G.coords);max(G.coords)];
G.W=diag(diag(Q.L))-Q.L;
