function [f_hat]=gsp_gft(f,U)
%GSP_GFT  Graph Fourier transform
%   Usage:  f_hat=gsp_gft(f,U);
%
%   Input parameters:
%         f          : Graph signal.
%         U          : Fourier basis (usually graph Laplacian eigenvectors)
%   Output parameters:
%         f_hat      : Graph Fourier transform of $f$.
%
%   'gsp_gft(f,U)' computes a graph Fourier transform of the signal $f$ with respect
%   to the Fourier basis $U$
%
%   .. f_hat = U* f 
%
%   .. math:: \hat{f}(\lambda_{\ell})=\langle f , u_{\ell} \rangle
%
%   See also:  
%
%   Demos:  
% 
%   References: 
%

%   AUTHOR : David I Shuman.
%   TESTING: 
%   REFERENCE:
  

f_hat=U'*f;