function [f]=gsp_igft(f_hat,U)
%GSP_GFT  Inverse graph Fourier transform
%   Usage:  f=gsp_igft(f_hat,U);
%
%   Input parameters:
%         f_hat      : Signal in graph Fourier domain.
%         U          : Fourier basis (usually graph Laplacian eigenvectors)
%   Output parameters:
%         f          : Inverse graph Fourier transform of $\hat{f}$.
%
%   'gsp_igft(f,U)' computes the inverse graph Fourier transform of the 
%   signal $\hat{f}$ with respect to the Fourier basis $U$
%
%   .. f = U f_hat 
%
%   .. math:: f(n)=\sum_{\ell=0}^{N-1} \hat{f}(\lambda_{\ell}) u_{\ell}(n)
%
%   See also:  
%
%   Demos:  
% 
%   References: 
%

%   AUTHOR : David I Shuman.
%   TESTING: 
%   REFERENCE:
  

f=U*f_hat;